/**
 * 
 */
package p;

import atomicsets.OrderedLock;

class AbstractList_Itr implements Iterator, atomicsets.Atomic {
		
	
public final OrderedLock getLockForI() {
		return $lock_I;
	}

	public final OrderedLock getLock() {
		return this.getLockForI();
	}

	public AbstractList_Itr(AbstractList al) {
		this(al, new OrderedLock());
	}

public AbstractList_Itr(AbstractList al/*L=this.I*/, OrderedLock I){
	$lock_I = I;
	this.abstractList = al;
	expectedModCount = abstractList.getModCount_internal();
}

/*atomic(I)*/ private final AbstractList abstractList/*L=this.I*/;

/**
 * Index of element to be returned by subsequent call to next.
 */
/*atomic(I)*/ private int cursor = 0;

/**
 * Index of element returned by most recent call to next or
 * previous.  Reset to -1 if this element is deleted by a call
 * to remove.
 */
/*atomic(I)*/ private int lastRet = -1;

/**
 * The modCount value that the iterator believes that the backing
 * List should have.  If this expectation is violated, the iterator
 * has detected concurrent modification.
 */
/*atomic(I)*/ private int expectedModCount;

public int getLastRet_internal(){
	return lastRet;
}

public int getLastRet() {
	synchronized (this.$lock_I) {
		return lastRet;
	}
}

public void setLastRet_internal(int l){
	lastRet = l;
}

public void setLastRet(int l) {
	synchronized (this.$lock_I) {
		lastRet = l;
	}
}

public int getCursor_internal(){
	return cursor;
}

public int getCursor() {
	synchronized (this.$lock_I) {
		return cursor;
	}
}

public int setCursor_internal(int c){
	cursor = c;
	return cursor;
}

public int setCursor(int c) {
	synchronized (this.$lock_I) {
		cursor = c;
		return cursor;
	}
}

public void setExpectedModCount_internal(int e){
	expectedModCount = e;
}

public void setExpectedModCount(int e) {
	synchronized (this.$lock_I) {
		expectedModCount = e;
	}
}

public AbstractList getAbstractList_internal(){
	return (AbstractList) abstractList;
}

public AbstractList getAbstractList() {
	return (AbstractList) abstractList;
}

public boolean hasNext_internal() {
        return cursor != abstractList.size_internal();
}

public boolean hasNext() {
	synchronized (this.$lock_I) {
		return cursor != abstractList.size_internal();
	}
}

public Object next_internal() {
        checkForComodification_internal();
    try {
	Object next = abstractList.get_internal(cursor);
	lastRet = cursor++;
	return next;
    } catch(IndexOutOfBoundsException e) {
	checkForComodification_internal();
	throw new NoSuchElementException();
    }
}

public Object next() {
	synchronized (this.$lock_I) {
		checkForComodification_internal();
		try {
		Object next = abstractList.get_internal(cursor);
		lastRet = cursor++;
		return next;
		} catch(IndexOutOfBoundsException e) {
		checkForComodification_internal();
		throw new NoSuchElementException();
		}
	}
}

public void remove_internal() {
    if (lastRet == -1)
	throw new IllegalStateException();
        checkForComodification_internal();

    try {
    	abstractList.remove_internal(lastRet);
	if (lastRet < cursor)
	    cursor--;
	lastRet = -1;
	expectedModCount = abstractList.getModCount_internal();
    } catch(IndexOutOfBoundsException e) {
	throw new ConcurrentModificationException();
    }
}

public void remove() {
	synchronized (this.$lock_I) {
		if (lastRet == -1)
		throw new IllegalStateException();
		checkForComodification_internal();
		try {
			abstractList.remove_internal(lastRet);
		if (lastRet < cursor)
		    cursor--;
		lastRet = -1;
		expectedModCount = abstractList.getModCount_internal();
		} catch(IndexOutOfBoundsException e) {
		throw new ConcurrentModificationException();
		}
	}
}

final void checkForComodification_internal() {
    if (abstractList.getModCount_internal() != expectedModCount)
	throw new ConcurrentModificationException();
}

final void checkForComodification() {
	synchronized (this.$lock_I) {
		if (abstractList.getModCount_internal() != expectedModCount)
		throw new ConcurrentModificationException();
	}
}

protected final OrderedLock $lock_I;
}