/*
 * Copyright (C) 2000 by ETHZ/INF/CS
 * All rights reserved
 * 
 * @version $Id: Floor.java,v 1.1 2010/06/01 17:56:52 cpa Exp $
 * @author Roger Karrer
 */

import java.lang.*;
import p.ArrayList;
import java.io.*;

// class to represent a floor in the control object
class Floor {

	/*atomicset(F)*/
	
    // Lists of people waiting to go up, and down
    // The Vectors will have instances of Integer objects.  The Integer will
    // store the floor that the person wants to go to
    /*atomic(F)*/ private ArrayList upPeople/*L=this.F*/;
    /*atomic(F)*/ private ArrayList downPeople/*L=this.F*/;

    // True if an elevator has claimed the the up or down call
    /*atomic(F)*/ private boolean upFlag;
    /*atomic(F)*/ private boolean downFlag;

    public boolean getUpFlag(){ return upFlag; }
    public void setUpFlag(boolean b){ upFlag = b; }
    public boolean getDownFlag(){ return downFlag; }
    public void setDownFlag(boolean b){ downFlag = b; }
    
    public ArrayList/*L=this.F*/ getUpPeople(){ return upPeople; } 
    public void clearUpPeople(){ upPeople = new ArrayList/*L=this.F*/(); }
    public ArrayList/*L=this.F*/ getDownPeople(){ return upPeople; } 
    public void clearDownPeople(){ downPeople = new ArrayList/*L=this.F*/(); }
    
    public Floor() {
		upPeople = new ArrayList/*L=this.F*/();
		downPeople = new ArrayList/*L=this.F*/();
		upFlag = false;
		downFlag = false;
    }
}
 
